/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2002 from the
 * contents of EV.xs. Do not edit this file, edit EV.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "EV.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* fix perl api breakage */
#undef signal
#undef sigaction

#include "schmorp.h"

/* old API compatibility */
static int
sv_fileno (SV *fh)
{
  return s_fileno (fh, 0);
}

#define EV_PROTOTYPES 1
#define EV_USE_NANOSLEEP EV_USE_MONOTONIC
#define EV_H <ev.h>
#include "EV/EVAPI.h"

#define EV_SELECT_IS_WINSOCKET 0
#ifdef _WIN32
# define EV_SELECT_USE_FD_SET 0
# define NFDBITS PERL_NFDBITS
# define fd_mask Perl_fd_mask
#endif
/* due to bugs in OS X we have to use libev/ explicitly here */
#include "libev/ev.c"

#ifndef _WIN32
# include <pthread.h>
#endif

#define e_loop(w) INT2PTR (struct ev_loop *, SvIVX ((w)->loop))

#define WFLAG_KEEPALIVE 1
#define WFLAG_UNREFED   2 /* has been unref'ed */

#define UNREF(w)				\
  if (!((w)->e_flags & (WFLAG_KEEPALIVE | WFLAG_UNREFED))	\
      && ev_is_active (w))			\
    {						\
      ev_unref (e_loop (w));			\
      (w)->e_flags |= WFLAG_UNREFED;		\
    }

#define REF(w)					\
  if ((w)->e_flags & WFLAG_UNREFED)		\
    {						\
      (w)->e_flags &= ~WFLAG_UNREFED;		\
      ev_ref (e_loop (w));			\
    }

#define START(type,w)				\
  do {						\
    ev_ ## type ## _start (e_loop (w), w);	\
    UNREF (w);					\
  } while (0)

#define STOP(type,w)				\
  do {						\
    REF (w);					\
    ev_ ## type ## _stop (e_loop (w), w);	\
  } while (0)

#define RESET(type,w,seta)			\
  do {                                          \
    int active = ev_is_active (w);              \
    if (active) STOP (type, w);                 \
    ev_ ## type ## _set seta;                   \
    if (active) START (type, w);                \
  } while (0)

typedef int Signal;

/* horrible... */
#define CHECK_SIGNAL_CAN_START(w)		\
  do {						\
    /* dive into the internals of libev to avoid aborting in libev */ \
    if (signals [(w)->signum - 1].loop		\
        && signals [(w)->signum - 1].loop != e_loop (w)) \
      croak ("unable to start signal watcher, signal %d already registered in another loop", w->signum); \
  } while (0)

#define START_SIGNAL(w)				\
  do {						\
    CHECK_SIGNAL_CAN_START (w);			\
    START (signal, w);				\
  } while (0)					\

#define RESET_SIGNAL(w,seta)			\
  do {                                          \
    int active = ev_is_active (w);              \
    if (active) STOP (signal, w);               \
    ev_ ## signal ## _set seta;                 \
    if (active) START_SIGNAL (w);               \
  } while (0)

static SV *default_loop_sv;

static struct EVAPI evapi;

static HV
  *stash_loop,
  *stash_watcher,
  *stash_io,
  *stash_timer,
  *stash_periodic,
  *stash_signal,
  *stash_child,
  *stash_stat,
  *stash_idle,
  *stash_prepare,
  *stash_check,
  *stash_embed,
  *stash_fork,
  *stash_async;

/////////////////////////////////////////////////////////////////////////////
// Event

static void e_cb (EV_P_ ev_watcher *w, int revents);

static void *
e_new (int size, SV *cb_sv, SV *loop)
{
  SV *cv = cb_sv ? s_get_cv_croak (cb_sv) : 0;
  ev_watcher *w;
  SV *self = NEWSV (0, size);
  SvPOK_only (self);
  SvCUR_set (self, size);

  w = (ev_watcher *)SvPVX (self);

  ev_init (w, cv ? e_cb : 0);

  w->loop    = SvREFCNT_inc (SvRV (loop));
  w->e_flags = WFLAG_KEEPALIVE;
  w->data    = 0;
  w->fh      = 0;
  w->cb_sv   = SvREFCNT_inc (cv);
  w->self    = self;

  return (void *)w;
}

static void
e_destroy (void *w_)
{
  ev_watcher *w = (ev_watcher *)w_;

  SvREFCNT_dec (w->loop ); w->loop  = 0;
  SvREFCNT_dec (w->fh   ); w->fh    = 0;
  SvREFCNT_dec (w->cb_sv); w->cb_sv = 0;
  SvREFCNT_dec (w->data ); w->data  = 0;
}

static SV *
e_bless (ev_watcher *w, HV *stash)
{
  SV *rv;

  if (SvOBJECT (w->self))
    rv = newRV_inc (w->self);
  else
    {
      rv = newRV_noinc (w->self);
      sv_bless (rv, stash);
      SvREADONLY_on (w->self);
    }

  return rv;
}

static SV *sv_self_cache, *sv_events_cache;

static void
e_cb (EV_P_ ev_watcher *w, int revents)
{
  dSP;
  I32 mark = SP - PL_stack_base;
  SV *sv_self, *sv_events;

  /* libev might have stopped the watcher */
  if (expect_false (w->e_flags & WFLAG_UNREFED)
      && !ev_is_active (w))
    REF (w);

  if (expect_true (sv_self_cache))
    {
      sv_self = sv_self_cache; sv_self_cache = 0;
      SvRV_set (sv_self, SvREFCNT_inc_NN (w->self));
    }
  else
    {
      sv_self = newRV_inc (w->self); /* w->self MUST be blessed by now */
      SvREADONLY_on (sv_self);
    }

  if (expect_true (sv_events_cache))
    {
      sv_events = sv_events_cache; sv_events_cache = 0;
      SvIV_set (sv_events, revents);
    }
  else
    {
      sv_events = newSViv (revents);
      SvREADONLY_on (sv_events);
    }

  PUSHMARK (SP);
  EXTEND (SP, 2);
  PUSHs (sv_self);
  PUSHs (sv_events);

  PUTBACK;
  call_sv (w->cb_sv, G_DISCARD | G_VOID | G_EVAL);

  if (expect_false (SvREFCNT (sv_self) != 1 || sv_self_cache))
    SvREFCNT_dec (sv_self);
  else
    {
      SvREFCNT_dec (SvRV (sv_self));
      SvRV_set (sv_self, &PL_sv_undef);
      sv_self_cache = sv_self;
    }

  if (expect_false (SvREFCNT (sv_events) != 1 || sv_events_cache))
    SvREFCNT_dec (sv_events);
  else
    sv_events_cache = sv_events;

  if (expect_false (SvTRUE (ERRSV)))
    {
      SPAGAIN;
      PUSHMARK (SP);
      PUTBACK;
      call_sv (get_sv ("EV::DIED", 1), G_DISCARD | G_VOID | G_EVAL | G_KEEPERR);
    }

  SP = PL_stack_base + mark;
  PUTBACK;
}

static void
e_once_cb (int revents, void *arg)
{
  dSP;
  I32 mark = SP - PL_stack_base;
  SV *sv_events;

  if (sv_events_cache)
    {
      sv_events = sv_events_cache; sv_events_cache = 0;
      SvIV_set (sv_events, revents);
    }
  else
    sv_events = newSViv (revents);

  PUSHMARK (SP);
  XPUSHs (sv_events);

  PUTBACK;
  call_sv ((SV *)arg, G_DISCARD | G_VOID | G_EVAL);

  SvREFCNT_dec ((SV *)arg);

  if (sv_events_cache)
    SvREFCNT_dec (sv_events);
  else
    sv_events_cache = sv_events;

  if (SvTRUE (ERRSV))
    {
      SPAGAIN;
      PUSHMARK (SP);
      PUTBACK;
      call_sv (get_sv ("EV::DIED", 1), G_DISCARD | G_VOID | G_EVAL | G_KEEPERR);
    }

  SP = PL_stack_base + mark;
  PUTBACK;
}

static ev_tstamp
e_periodic_cb (ev_periodic *w, ev_tstamp now)
{
  ev_tstamp retval;
  int count;
  dSP;

  ENTER;
  SAVETMPS;

  PUSHMARK (SP);
  EXTEND (SP, 2);
  PUSHs (newRV_inc (w->self)); /* w->self MUST be blessed by now */
  PUSHs (newSVnv (now));

  PUTBACK;
  count = call_sv (w->fh, G_SCALAR | G_EVAL);
  SPAGAIN;

  if (SvTRUE (ERRSV))
    {
      PUSHMARK (SP);
      PUTBACK;
      call_sv (get_sv ("EV::DIED", 1), G_DISCARD | G_VOID | G_EVAL | G_KEEPERR);
      SPAGAIN;
    }

  if (count > 0)
    {
      retval = SvNV (TOPs);

      if (retval < now)
        retval = now;
    }
  else
    retval = now;

  FREETMPS;
  LEAVE;

  return retval;
}

#define CHECK_REPEAT(repeat) if (repeat < 0.) \
  croak (# repeat " value must be >= 0");

#define CHECK_FD(fh,fd) if ((fd) < 0) \
  croak ("illegal file descriptor or filehandle (either no attached file descriptor or illegal value): %s", SvPV_nolen (fh));

#define CHECK_SIG(sv,num) if ((num) < 0) \
  croak ("illegal signal number or name: %s", SvPV_nolen (sv));

/////////////////////////////////////////////////////////////////////////////
// XS interface functions

#line 352 "EV.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

#line 395 "EV.c"

XS(XS_EV_default_loop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_default_loop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "flags= 0");
    {
	SV *	RETVAL;
	unsigned int	flags;

	if (items < 1)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(0));
	}
#line 498 "EV.xs"
{
	if (!default_loop_sv)
          {
            evapi.default_loop = ev_default_loop (flags);

            if (!evapi.default_loop)
              XSRETURN_UNDEF;

            default_loop_sv = sv_bless (newRV_noinc (newSViv (PTR2IV (evapi.default_loop))), stash_loop);
          }

        RETVAL = newSVsv (default_loop_sv);
}
#line 430 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_default_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_default_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 516 "EV.xs"
        ev_default_destroy ();
        SvREFCNT_dec (default_loop_sv);
        default_loop_sv = 0;
#line 453 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_supported_backends); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_supported_backends)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_supported_backends();
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_recommended_backends); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_recommended_backends)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_recommended_backends();
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_embeddable_backends); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_embeddable_backends)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_embeddable_backends();
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_sleep); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_sleep)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "interval");
    {
	NV	interval = (NV)SvNV(ST(0));

	ev_sleep(interval);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	NV	RETVAL;
	dXSTARG;

	RETVAL = ev_time();
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_now); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_now)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	NV	RETVAL;
	dXSTARG;

	RETVAL = ev_now(evapi.default_loop);
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_now_update); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_now_update)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {

	ev_now_update(evapi.default_loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_suspend); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_suspend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {

	ev_suspend(evapi.default_loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_resume); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_resume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {

	ev_resume(evapi.default_loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_backend); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_backend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_backend(evapi.default_loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_loop_verify); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_loop_verify)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {

	ev_loop_verify(evapi.default_loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_loop_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_loop_count)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_loop_count(evapi.default_loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_loop_depth); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_loop_depth)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_loop_depth(evapi.default_loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_set_io_collect_interval); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_set_io_collect_interval)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "interval");
    {
	NV	interval = (NV)SvNV(ST(0));

	ev_set_io_collect_interval(evapi.default_loop, interval);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_set_timeout_collect_interval); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_set_timeout_collect_interval)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "interval");
    {
	NV	interval = (NV)SvNV(ST(0));

	ev_set_timeout_collect_interval(evapi.default_loop, interval);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_loop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_loop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "flags= 0");
    {
	int	flags;

	if (items < 1)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(0));
	}

	ev_loop(evapi.default_loop, flags);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_unloop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_unloop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "how= EVUNLOOP_ONE");
    {
	int	how;

	if (items < 1)
	    how = EVUNLOOP_ONE;
	else {
	    how = (int)SvIV(ST(0));
	}

	ev_unloop(evapi.default_loop, how);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_feed_fd_event); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_feed_fd_event)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "fd, revents= EV_NONE");
    {
	int	fd = (int)SvIV(ST(0));
	int	revents;

	if (items < 2)
	    revents = EV_NONE;
	else {
	    revents = (int)SvIV(ST(1));
	}

	ev_feed_fd_event(evapi.default_loop, fd, revents);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_feed_signal_event); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_feed_signal_event)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "signal");
    {
	SV *	signal = ST(0);
#line 571 "EV.xs"
{
  	Signal signum = s_signum (signal);
        CHECK_SIG (signal, signum);

        ev_feed_signal_event (evapi.default_loop, signum);
}
#line 851 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_pending_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_pending_count)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_pending_count(evapi.default_loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_invoke_pending); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_invoke_pending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {

	ev_invoke_pending(evapi.default_loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_io); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_io)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "fh, events, cb");
    {
	ev_io *	RETVAL;
	SV *	fh = ST(0);
	int	events = (int)SvIV(ST(1));
	SV *	cb = ST(2);
#line 589 "EV.xs"
{
	int fd = s_fileno (fh, events & EV_WRITE);
        CHECK_FD (fh, fd);

        if (ix == 2)
          {
            ix = 0;
            events = events ? EV_WRITE : EV_READ;
          }

        RETVAL = e_new (sizeof (ev_io), cb, default_loop_sv);
        RETVAL->fh = newSVsv (fh);
        ev_io_set (RETVAL, fd, events);
        if (!ix) START (io, RETVAL);
}
#line 928 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_io);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_timer); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_timer)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "after, repeat, cb");
    {
	ev_timer *	RETVAL;
	NV	after = (NV)SvNV(ST(0));
	NV	repeat = (NV)SvNV(ST(1));
	SV *	cb = ST(2);
#line 611 "EV.xs"
        CHECK_REPEAT (repeat);
#line 956 "EV.c"
#line 613 "EV.xs"
        RETVAL = e_new (sizeof (ev_timer), cb, default_loop_sv);
        ev_timer_set (RETVAL, after, repeat);
        if (!ix) START (timer, RETVAL);
#line 961 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_timer);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_periodic); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_periodic)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "at, interval, reschedule_cb, cb");
    {
	SV *	RETVAL;
	NV	at = (NV)SvNV(ST(0));
	NV	interval = (NV)SvNV(ST(1));
	SV *	reschedule_cb = ST(2);
	SV *	cb = ST(3);
#line 623 "EV.xs"
        CHECK_REPEAT (interval);
#line 990 "EV.c"
#line 625 "EV.xs"
{
  	ev_periodic *w;
        w = e_new (sizeof (ev_periodic), cb, default_loop_sv);
        w->fh = SvTRUE (reschedule_cb) ? newSVsv (reschedule_cb) : 0;
        ev_periodic_set (w, at, interval, w->fh ? e_periodic_cb : 0);
        RETVAL = e_bless ((ev_watcher *)w, stash_periodic);
        if (!ix) START (periodic, w);
}
#line 1000 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_signal); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_signal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "signal, cb");
    {
	ev_signal *	RETVAL;
	SV *	signal = ST(0);
	SV *	cb = ST(1);
#line 640 "EV.xs"
{
  	Signal signum = s_signum (signal);
        CHECK_SIG (signal, signum);

        RETVAL = e_new (sizeof (ev_signal), cb, default_loop_sv);
        ev_signal_set (RETVAL, signum);
        if (!ix) START_SIGNAL (RETVAL);
}
#line 1032 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_signal);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_idle); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_idle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	ev_idle *	RETVAL;
	SV *	cb = ST(0);
#line 655 "EV.xs"
        RETVAL = e_new (sizeof (ev_idle), cb, default_loop_sv);
        ev_idle_set (RETVAL);
        if (!ix) START (idle, RETVAL);
#line 1060 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_idle);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_prepare); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_prepare)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	ev_prepare *	RETVAL;
	SV *	cb = ST(0);
#line 665 "EV.xs"
        RETVAL = e_new (sizeof (ev_prepare), cb, default_loop_sv);
        ev_prepare_set (RETVAL);
        if (!ix) START (prepare, RETVAL);
#line 1088 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_prepare);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_check); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_check)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	ev_check *	RETVAL;
	SV *	cb = ST(0);
#line 675 "EV.xs"
        RETVAL = e_new (sizeof (ev_check), cb, default_loop_sv);
        ev_check_set (RETVAL);
        if (!ix) START (check, RETVAL);
#line 1116 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_check);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_fork); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_fork)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	ev_fork *	RETVAL;
	SV *	cb = ST(0);
#line 685 "EV.xs"
        RETVAL = e_new (sizeof (ev_fork), cb, default_loop_sv);
        ev_fork_set (RETVAL);
        if (!ix) START (fork, RETVAL);
#line 1144 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_fork);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_child); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_child)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "pid, trace, cb");
    {
	ev_child *	RETVAL;
	int	pid = (int)SvIV(ST(0));
	int	trace = (int)SvIV(ST(1));
	SV *	cb = ST(2);
#line 695 "EV.xs"
        RETVAL = e_new (sizeof (ev_child), cb, default_loop_sv);
        ev_child_set (RETVAL, pid, trace);
        if (!ix) START (child, RETVAL);
#line 1174 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_child);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_stat); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_stat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "path, interval, cb");
    {
	ev_stat *	RETVAL;
	SV *	path = ST(0);
	NV	interval = (NV)SvNV(ST(1));
	SV *	cb = ST(2);
#line 705 "EV.xs"
        RETVAL = e_new (sizeof (ev_stat), cb, default_loop_sv);
        RETVAL->fh = newSVsv (path);
        ev_stat_set (RETVAL, SvPVbyte_nolen (RETVAL->fh), interval);
        if (!ix) START (stat, RETVAL);
#line 1205 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_stat);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_embed); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_embed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "loop, cb= 0");
    {
	ev_embed *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	if (items < 2)
	    cb = 0;
	else {
	    cb = ST(1);
	}
#line 716 "EV.xs"
{
        if (!(ev_backend (loop) & ev_embeddable_backends ()))
          croak ("passed loop is not embeddable via EV::embed,");

        RETVAL = e_new (sizeof (ev_embed), cb, default_loop_sv);
        RETVAL->fh = newSVsv (ST (0));
        ev_embed_set (RETVAL, loop);
        if (!ix) START (embed, RETVAL);
}
#line 1251 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_embed);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_async); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_async)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	ev_async *	RETVAL;
	SV *	cb = ST(0);
#line 732 "EV.xs"
        RETVAL = e_new (sizeof (ev_async), cb, default_loop_sv);
        ev_async_set (RETVAL);
        if (!ix) START (async, RETVAL);
#line 1279 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_async);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_once); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_once)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "fh, events, timeout, cb");
    {
	SV *	fh = ST(0);
	int	events = (int)SvIV(ST(1));
	SV *	timeout = ST(2);
	SV *	cb = ST(3);
#line 740 "EV.xs"
        ev_once (
           evapi.default_loop,
           s_fileno (fh, events & EV_WRITE), events,
           SvOK (timeout) ? SvNV (timeout) : -1.,
           e_once_cb,
           newSVsv (cb)
        );
#line 1312 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Watcher_is_active); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_is_active)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	RETVAL = ev_is_active(w);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Watcher_is_pending); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_is_pending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	RETVAL = ev_is_pending(w);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Watcher_invoke); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_invoke)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, revents= EV_NONE");
    {
	ev_watcher *	w;
	int	revents;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    revents = EV_NONE;
	else {
	    revents = (int)SvIV(ST(1));
	}

	ev_invoke(e_loop (w), w, revents);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Watcher_clear_pending); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_clear_pending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	RETVAL = ev_clear_pending(e_loop (w), w);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Watcher_feed_event); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_feed_event)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, revents= EV_NONE");
    {
	ev_watcher *	w;
	int	revents;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    revents = EV_NONE;
	else {
	    revents = (int)SvIV(ST(1));
	}

	ev_feed_event(e_loop (w), w, revents);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Watcher_keepalive); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_keepalive)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_value= 0");
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;
	int	new_value;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_value = 0;
	else {
	    new_value = (int)SvIV(ST(1));
	}
#line 767 "EV.xs"
{
        RETVAL = w->e_flags & WFLAG_KEEPALIVE;
        new_value = new_value ? WFLAG_KEEPALIVE : 0;

        if (items > 1 && ((new_value ^ w->e_flags) & WFLAG_KEEPALIVE))
          {
            w->e_flags = (w->e_flags & ~WFLAG_KEEPALIVE) | new_value;
            REF (w);
            UNREF (w);
          }
}
#line 1505 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Watcher_cb); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_cb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_cb= 0");
    {
	SV *	RETVAL;
	ev_watcher *	w;
	SV *	new_cb;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_cb = 0;
	else {
	    new_cb = ST(1);
	}
#line 783 "EV.xs"
{
        if (items > 1)
          {
            new_cb = s_get_cv_croak (new_cb);
            RETVAL = newRV_noinc (w->cb_sv);
            w->cb_sv = SvREFCNT_inc (new_cb);
          }
        else
          RETVAL = newRV_inc (w->cb_sv);
}
#line 1549 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Watcher_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_data)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_data= 0");
    {
	SV *	RETVAL;
	ev_watcher *	w;
	SV *	new_data;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_data = 0;
	else {
	    new_data = ST(1);
	}
#line 798 "EV.xs"
{
	RETVAL = w->data ? newSVsv (w->data) : &PL_sv_undef;

        if (items > 1)
          {
            SvREFCNT_dec (w->data);
            w->data = newSVsv (new_data);
          }
}
#line 1593 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Watcher_loop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_loop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	SV *	RETVAL;
	ev_watcher *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));
#line 812 "EV.xs"
	RETVAL = newRV_inc (w->loop);
#line 1622 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Watcher_priority); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_priority)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_priority= 0");
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;
	int	new_priority;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_priority = 0;
	else {
	    new_priority = (int)SvIV(ST(1));
	}
#line 818 "EV.xs"
{
        RETVAL = w->priority;

        if (items > 1)
          {
            int active = ev_is_active (w);

            if (active)
              {
                /* grrr. */
                PUSHMARK (SP);
                XPUSHs (ST (0));
                PUTBACK;
                call_method ("stop", G_DISCARD | G_VOID);
              }

            ev_set_priority (w, new_priority);

            if (active)
              {
                PUSHMARK (SP);
                XPUSHs (ST (0));
                PUTBACK;
                call_method ("start", G_DISCARD | G_VOID);
              }
          }
}
#line 1685 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__IO_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__IO_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_io *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)));
#line 852 "EV.xs"
        START (io, w);
#line 1712 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__IO_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__IO_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_io *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)));
#line 856 "EV.xs"
        STOP (io, w);
#line 1738 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__IO_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__IO_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_io *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)));
#line 860 "EV.xs"
        STOP (io, w);
        e_destroy (w);
#line 1765 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__IO_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__IO_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "w, fh, events");
    {
	ev_io *	w;
	SV *	fh = ST(1);
	int	events = (int)SvIV(ST(2));

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)));
#line 865 "EV.xs"
{
	int fd = s_fileno (fh, events & EV_WRITE);
        CHECK_FD (fh, fd);

        sv_setsv (w->fh, fh);
        RESET (io, w, (w, fd, events));
}
#line 1799 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__IO_fh); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__IO_fh)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_fh= 0");
    {
	SV *	RETVAL;
	ev_io *	w;
	SV *	new_fh;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_fh = 0;
	else {
	    new_fh = ST(1);
	}
#line 875 "EV.xs"
{
        if (items > 1)
          {
            int fd = s_fileno (new_fh, w->events & EV_WRITE);
            CHECK_FD (new_fh, fd);

            RETVAL = w->fh;
            w->fh = newSVsv (new_fh);

            RESET (io, w, (w, fd, w->events));
          }
        else
          RETVAL = newSVsv (w->fh);
}
#line 1846 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__IO_events); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__IO_events)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_events= EV_UNDEF");
    {
	int	RETVAL;
	dXSTARG;
	ev_io *	w;
	int	new_events;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_events = EV_UNDEF;
	else {
	    new_events = (int)SvIV(ST(1));
	}
#line 894 "EV.xs"
{
        RETVAL = w->events;

        if (items > 1)
          RESET (io, w, (w, w->fd, new_events));
}
#line 1888 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Signal_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Signal_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_signal *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)));
#line 907 "EV.xs"
        START_SIGNAL (w);
#line 1915 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Signal_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Signal_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_signal *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)));
#line 911 "EV.xs"
        STOP (signal, w);
#line 1941 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Signal_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Signal_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_signal *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)));
#line 915 "EV.xs"
        STOP (signal, w);
        e_destroy (w);
#line 1968 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Signal_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Signal_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "w, signal");
    {
	ev_signal *	w;
	SV *	signal = ST(1);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)));
#line 920 "EV.xs"
{
	Signal signum = s_signum (signal);
        CHECK_SIG (signal, signum);

        RESET_SIGNAL (w, (w, signum));
}
#line 2000 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Signal_signal); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Signal_signal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_signal= 0");
    {
	int	RETVAL;
	dXSTARG;
	ev_signal *	w;
	SV *	new_signal;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_signal = 0;
	else {
	    new_signal = ST(1);
	}
#line 929 "EV.xs"
{
        RETVAL = w->signum;

        if (items > 1)
          {
            Signal signum = s_signum (new_signal);
            CHECK_SIG (new_signal, signum);

            RESET_SIGNAL (w, (w, signum));
          }
}
#line 2045 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Timer_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Timer_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_timer *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)));
#line 947 "EV.xs"
        CHECK_REPEAT (w->repeat);
#line 2072 "EV.c"
#line 949 "EV.xs"
        START (timer, w);
#line 2075 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Timer_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Timer_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_timer *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)));
#line 953 "EV.xs"
        STOP (timer, w);
#line 2101 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Timer_again); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Timer_again)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_timer *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)));
#line 957 "EV.xs"
        CHECK_REPEAT (w->repeat);
#line 2127 "EV.c"
#line 959 "EV.xs"
        ev_timer_again (e_loop (w), w);
        UNREF (w);
#line 2131 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Timer_remaining); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Timer_remaining)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	NV	RETVAL;
	dXSTARG;
	ev_timer *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)));

	RETVAL = ev_timer_remaining(e_loop (w), w);
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Timer_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Timer_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_timer *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)));
#line 967 "EV.xs"
        STOP (timer, w);
        e_destroy (w);
#line 2186 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Timer_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Timer_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "w, after, repeat= 0.");
    {
	ev_timer *	w;
	NV	after = (NV)SvNV(ST(1));
	NV	repeat;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)));

	if (items < 3)
	    repeat = 0.;
	else {
	    repeat = (NV)SvNV(ST(2));
	}
#line 972 "EV.xs"
        CHECK_REPEAT (repeat);
#line 2220 "EV.c"
#line 974 "EV.xs"
        RESET (timer, w, (w, after, repeat));
#line 2223 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Periodic_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Periodic_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)));
#line 980 "EV.xs"
        CHECK_REPEAT (w->interval);
#line 2249 "EV.c"
#line 982 "EV.xs"
        START (periodic, w);
#line 2252 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Periodic_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Periodic_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)));
#line 986 "EV.xs"
        STOP (periodic, w);
#line 2278 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Periodic_again); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Periodic_again)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)));
#line 990 "EV.xs"
        ev_periodic_again (e_loop (w), w);
        UNREF (w);
#line 2305 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Periodic_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Periodic_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)));
#line 995 "EV.xs"
        STOP (periodic, w);
        e_destroy (w);
#line 2332 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Periodic_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Periodic_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "w, at, interval= 0., reschedule_cb= &PL_sv_undef");
    {
	ev_periodic *	w;
	NV	at = (NV)SvNV(ST(1));
	NV	interval;
	SV *	reschedule_cb;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)));

	if (items < 3)
	    interval = 0.;
	else {
	    interval = (NV)SvNV(ST(2));
	}

	if (items < 4)
	    reschedule_cb = &PL_sv_undef;
	else {
	    reschedule_cb = ST(3);
	}
#line 1000 "EV.xs"
        CHECK_REPEAT (interval);
#line 2373 "EV.c"
#line 1002 "EV.xs"
{
        SvREFCNT_dec (w->fh);
        w->fh = SvTRUE (reschedule_cb) ? newSVsv (reschedule_cb) : 0;

        RESET (periodic, w, (w, at, interval, w->fh ? e_periodic_cb : 0));
}
#line 2381 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Periodic_at); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Periodic_at)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	NV	RETVAL;
	dXSTARG;
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)));
#line 1011 "EV.xs"
        RETVAL = ev_periodic_at (w);
#line 2409 "EV.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Idle_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Idle_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_idle *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_idle
                  || sv_derived_from (ST(0), "EV::Idle"))))
          croak ("object is not of type EV::Idle");
	w = (ev_idle *)SvPVX (SvRV (ST(0)));
#line 1019 "EV.xs"
        START (idle, w);
#line 2436 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Idle_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Idle_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_idle *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_idle
                  || sv_derived_from (ST(0), "EV::Idle"))))
          croak ("object is not of type EV::Idle");
	w = (ev_idle *)SvPVX (SvRV (ST(0)));
#line 1023 "EV.xs"
        STOP (idle, w);
#line 2462 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Idle_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Idle_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_idle *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_idle
                  || sv_derived_from (ST(0), "EV::Idle"))))
          croak ("object is not of type EV::Idle");
	w = (ev_idle *)SvPVX (SvRV (ST(0)));
#line 1027 "EV.xs"
        STOP (idle, w);
        e_destroy (w);
#line 2489 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Prepare_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Prepare_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_prepare *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_prepare
                  || sv_derived_from (ST(0), "EV::Prepare"))))
          croak ("object is not of type EV::Prepare");
	w = (ev_prepare *)SvPVX (SvRV (ST(0)));
#line 1034 "EV.xs"
        START (prepare, w);
#line 2515 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Prepare_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Prepare_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_prepare *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_prepare
                  || sv_derived_from (ST(0), "EV::Prepare"))))
          croak ("object is not of type EV::Prepare");
	w = (ev_prepare *)SvPVX (SvRV (ST(0)));
#line 1038 "EV.xs"
        STOP (prepare, w);
#line 2541 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Prepare_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Prepare_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_prepare *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_prepare
                  || sv_derived_from (ST(0), "EV::Prepare"))))
          croak ("object is not of type EV::Prepare");
	w = (ev_prepare *)SvPVX (SvRV (ST(0)));
#line 1042 "EV.xs"
        STOP (prepare, w);
        e_destroy (w);
#line 2568 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Check_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Check_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_check *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_check
                  || sv_derived_from (ST(0), "EV::Check"))))
          croak ("object is not of type EV::Check");
	w = (ev_check *)SvPVX (SvRV (ST(0)));
#line 1049 "EV.xs"
        START (check, w);
#line 2594 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Check_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Check_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_check *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_check
                  || sv_derived_from (ST(0), "EV::Check"))))
          croak ("object is not of type EV::Check");
	w = (ev_check *)SvPVX (SvRV (ST(0)));
#line 1053 "EV.xs"
        STOP (check, w);
#line 2620 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Check_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Check_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_check *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_check
                  || sv_derived_from (ST(0), "EV::Check"))))
          croak ("object is not of type EV::Check");
	w = (ev_check *)SvPVX (SvRV (ST(0)));
#line 1057 "EV.xs"
        STOP (check, w);
        e_destroy (w);
#line 2647 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Fork_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Fork_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_fork *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_fork
                  || sv_derived_from (ST(0), "EV::Fork"))))
          croak ("object is not of type EV::Fork");
	w = (ev_fork *)SvPVX (SvRV (ST(0)));
#line 1064 "EV.xs"
        START (fork, w);
#line 2673 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Fork_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Fork_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_fork *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_fork
                  || sv_derived_from (ST(0), "EV::Fork"))))
          croak ("object is not of type EV::Fork");
	w = (ev_fork *)SvPVX (SvRV (ST(0)));
#line 1068 "EV.xs"
        STOP (fork, w);
#line 2699 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Fork_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Fork_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_fork *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_fork
                  || sv_derived_from (ST(0), "EV::Fork"))))
          croak ("object is not of type EV::Fork");
	w = (ev_fork *)SvPVX (SvRV (ST(0)));
#line 1072 "EV.xs"
        STOP (fork, w);
        e_destroy (w);
#line 2726 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Child_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Child_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_child *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)));
#line 1079 "EV.xs"
        START (child, w);
#line 2752 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Child_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Child_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_child *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)));
#line 1083 "EV.xs"
        STOP (child, w);
#line 2778 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Child_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Child_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_child *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)));
#line 1087 "EV.xs"
        STOP (child, w);
        e_destroy (w);
#line 2805 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Child_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Child_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "w, pid, trace");
    {
	ev_child *	w;
	int	pid = (int)SvIV(ST(1));
	int	trace = (int)SvIV(ST(2));

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)));
#line 1092 "EV.xs"
        RESET (child, w, (w, pid, trace));
#line 2833 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Child_pid); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Child_pid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	int	RETVAL;
	dXSTARG;
	ev_child *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)));
#line 1099 "EV.xs"
        RETVAL = ix == 0 ? w->pid
               : ix == 1 ? w->rpid
               :           w->rstatus;
#line 2864 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Stat_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Stat_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_stat *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)));
#line 1109 "EV.xs"
        START (stat, w);
#line 2891 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Stat_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Stat_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_stat *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)));
#line 1113 "EV.xs"
        STOP (stat, w);
#line 2917 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Stat_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Stat_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_stat *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)));
#line 1117 "EV.xs"
        STOP (stat, w);
        e_destroy (w);
#line 2944 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Stat_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Stat_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "w, path, interval");
    {
	ev_stat *	w;
	SV *	path = ST(1);
	NV	interval = (NV)SvNV(ST(2));

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)));
#line 1122 "EV.xs"
{
        sv_setsv (w->fh, path);
	RESET (stat, w, (w, SvPVbyte_nolen (w->fh), interval));
}
#line 2975 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Stat_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Stat_path)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_path= 0");
    {
	SV *	RETVAL;
	ev_stat *	w;
	SV *	new_path;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_path = 0;
	else {
	    new_path = ST(1);
	}
#line 1129 "EV.xs"
{
        RETVAL = SvREFCNT_inc (w->fh);

        if (items > 1)
          {
            SvREFCNT_dec (w->fh);
            w->fh = newSVsv (new_path);
            RESET (stat, w, (w, SvPVbyte_nolen (w->fh), w->interval));
          }
}
#line 3018 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Stat_interval); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Stat_interval)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_interval= 0.");
    {
	NV	RETVAL;
	dXSTARG;
	ev_stat *	w;
	NV	new_interval;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_interval = 0.;
	else {
	    new_interval = (NV)SvNV(ST(1));
	}
#line 1144 "EV.xs"
{
        RETVAL = w->interval;

        if (items > 1)
          RESET (stat, w, (w, SvPVbyte_nolen (w->fh), new_interval));
}
#line 3060 "EV.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Stat_prev); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Stat_prev)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	ev_stat *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)));
#line 1158 "EV.xs"
{
	ev_statdata *s = ix ? &w->attr : &w->prev;

        if (ix == 1)
          ev_stat_stat (e_loop (w), w);
        else if (!s->st_nlink)
          errno = ENOENT;

        PL_statcache.st_dev   = s->st_nlink;
        PL_statcache.st_ino   = s->st_ino;
        PL_statcache.st_mode  = s->st_mode;
        PL_statcache.st_nlink = s->st_nlink;
        PL_statcache.st_uid   = s->st_uid;
        PL_statcache.st_gid   = s->st_gid;
        PL_statcache.st_rdev  = s->st_rdev;
        PL_statcache.st_size  = s->st_size;
        PL_statcache.st_atime = s->st_atime;
        PL_statcache.st_mtime = s->st_mtime;
        PL_statcache.st_ctime = s->st_ctime;

        if (GIMME_V == G_SCALAR)
          XPUSHs (boolSV (s->st_nlink));
        else if (GIMME_V == G_ARRAY && s->st_nlink)
          {
            EXTEND (SP, 13);
            PUSHs (sv_2mortal (newSViv (s->st_dev)));
            PUSHs (sv_2mortal (newSViv (s->st_ino)));
            PUSHs (sv_2mortal (newSVuv (s->st_mode)));
            PUSHs (sv_2mortal (newSVuv (s->st_nlink)));
            PUSHs (sv_2mortal (newSViv (s->st_uid)));
            PUSHs (sv_2mortal (newSViv (s->st_gid)));
            PUSHs (sv_2mortal (newSViv (s->st_rdev)));
            PUSHs (sv_2mortal (newSVnv ((NV)s->st_size)));
            PUSHs (sv_2mortal (newSVnv (s->st_atime)));
            PUSHs (sv_2mortal (newSVnv (s->st_mtime)));
            PUSHs (sv_2mortal (newSVnv (s->st_ctime)));
            PUSHs (sv_2mortal (newSVuv (4096)));
            PUSHs (sv_2mortal (newSVnv ((NV)((s->st_size + 4095) / 4096))));
          }
}
#line 3129 "EV.c"
	PUTBACK;
	return;
    }
}


XS(XS_EV__Embed_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Embed_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)));
#line 1203 "EV.xs"
        START (embed, w);
#line 3156 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Embed_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Embed_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)));
#line 1207 "EV.xs"
        STOP (embed, w);
#line 3182 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Embed_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Embed_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)));
#line 1211 "EV.xs"
        STOP (embed, w);
        e_destroy (w);
#line 3209 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Embed_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Embed_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "w, loop");
    {
	ev_embed *	w;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)));

	if (!(SvROK (ST(1)) && SvOBJECT (SvRV (ST(1)))
              && (SvSTASH (SvRV (ST(1))) == stash_loop || sv_derived_from (ST(1), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(1)));
#line 1216 "EV.xs"
{
        sv_setsv (w->fh, ST (1));
	RESET (embed, w, (w, loop));
}
#line 3244 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Embed_other); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Embed_other)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	SV *	RETVAL;
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)));
#line 1223 "EV.xs"
        RETVAL = newSVsv (w->fh);
#line 3271 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Embed_sweep); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Embed_sweep)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)));

	ev_embed_sweep(e_loop (w), w);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Async_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Async_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)));
#line 1234 "EV.xs"
        START (async, w);
#line 3324 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Async_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Async_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)));
#line 1238 "EV.xs"
        STOP (async, w);
#line 3350 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Async_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Async_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)));
#line 1242 "EV.xs"
        STOP (async, w);
        e_destroy (w);
#line 3377 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Async_send); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Async_send)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)));

	ev_async_send(e_loop (w), w);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Async_async_pending); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Async_async_pending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	SV *	RETVAL;
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)));
#line 1250 "EV.xs"
        RETVAL = boolSV (ev_async_pending (w));
#line 3429 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "klass, flags= 0");
    {
	SV *	RETVAL;
	SV *	klass = ST(0);
	unsigned int	flags;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 1258 "EV.xs"
{
	struct ev_loop *loop = ev_loop_new (flags);

        if (!loop)
          XSRETURN_UNDEF;

        RETVAL = sv_bless (newRV_noinc (newSViv (PTR2IV (loop))), stash_loop);
}
#line 3466 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1271 "EV.xs"
        if (loop != evapi.default_loop) /* global destruction sucks */
          ev_loop_destroy (loop);
#line 3494 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_loop_fork); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_loop_fork)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_loop_fork(loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_loop_verify); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_loop_verify)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_loop_verify(loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_now); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_now)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	NV	RETVAL;
	dXSTARG;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	RETVAL = ev_now(loop);
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_now_update); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_now_update)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_now_update(loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_suspend); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_suspend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_suspend(loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_resume); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_resume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_resume(loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_set_io_collect_interval); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_set_io_collect_interval)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "loop, interval");
    {
	struct ev_loop *	loop;
	NV	interval = (NV)SvNV(ST(1));

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_set_io_collect_interval(loop, interval);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_set_timeout_collect_interval); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_set_timeout_collect_interval)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "loop, interval");
    {
	struct ev_loop *	loop;
	NV	interval = (NV)SvNV(ST(1));

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_set_timeout_collect_interval(loop, interval);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_backend); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_backend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	unsigned int	RETVAL;
	dXSTARG;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	RETVAL = ev_backend(loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_loop_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_loop_count)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	unsigned int	RETVAL;
	dXSTARG;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	RETVAL = ev_loop_count(loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_loop_depth); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_loop_depth)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	unsigned int	RETVAL;
	dXSTARG;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	RETVAL = ev_loop_depth(loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_loop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_loop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "loop, flags= 0");
    {
	struct ev_loop *	loop;
	int	flags;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}

	ev_loop(loop, flags);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_unloop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_unloop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "loop, how= 1");
    {
	struct ev_loop *	loop;
	int	how;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	if (items < 2)
	    how = 1;
	else {
	    how = (int)SvIV(ST(1));
	}

	ev_unloop(loop, how);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_feed_fd_event); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_feed_fd_event)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "loop, fd, revents= EV_NONE");
    {
	struct ev_loop *	loop;
	int	fd = (int)SvIV(ST(1));
	int	revents;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	if (items < 3)
	    revents = EV_NONE;
	else {
	    revents = (int)SvIV(ST(2));
	}

	ev_feed_fd_event(loop, fd, revents);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_pending_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_pending_count)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	unsigned int	RETVAL;
	dXSTARG;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	RETVAL = ev_pending_count(loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_invoke_pending); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_invoke_pending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_invoke_pending(loop);
    }
    XSRETURN_EMPTY;
}

#if 0
#define XSubPPtmpAAAA 1


XS(XS_EV__Loop_feed_signal_event); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_feed_signal_event)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "loop, signal");
    {
	struct ev_loop *	loop;
	SV *	signal = ST(1);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1310 "EV.xs"
{
  	Signal signum = s_signum (signal);
        CHECK_SIG (signal, signum);

        ev_feed_signal_event (loop, signum);
}
#line 3951 "EV.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS(XS_EV__Loop_io); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_io)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "loop, fh, events, cb");
    {
	ev_io *	RETVAL;
	struct ev_loop *	loop;
	SV *	fh = ST(1);
	int	events = (int)SvIV(ST(2));
	SV *	cb = ST(3);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1323 "EV.xs"
{
	int fd = s_fileno (fh, events & EV_WRITE);
        CHECK_FD (fh, fd);

        RETVAL = e_new (sizeof (ev_io), cb, ST (0));
        RETVAL->fh = newSVsv (fh);
        ev_io_set (RETVAL, fd, events);
        if (!ix) START (io, RETVAL);
}
#line 3990 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_io);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_timer); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_timer)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "loop, after, repeat, cb");
    {
	ev_timer *	RETVAL;
	struct ev_loop *	loop;
	NV	after = (NV)SvNV(ST(1));
	NV	repeat = (NV)SvNV(ST(2));
	SV *	cb = ST(3);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1339 "EV.xs"
        CHECK_REPEAT (repeat);
#line 4024 "EV.c"
#line 1341 "EV.xs"
        RETVAL = e_new (sizeof (ev_timer), cb, ST (0));
        ev_timer_set (RETVAL, after, repeat);
        if (!ix) START (timer, RETVAL);
#line 4029 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_timer);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_periodic); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_periodic)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 5)
       croak_xs_usage(cv,  "loop, at, interval, reschedule_cb, cb");
    {
	SV *	RETVAL;
	struct ev_loop *	loop;
	NV	at = (NV)SvNV(ST(1));
	NV	interval = (NV)SvNV(ST(2));
	SV *	reschedule_cb = ST(3);
	SV *	cb = ST(4);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1351 "EV.xs"
        CHECK_REPEAT (interval);
#line 4064 "EV.c"
#line 1353 "EV.xs"
{
  	ev_periodic *w;
        w = e_new (sizeof (ev_periodic), cb, ST (0));
        w->fh = SvTRUE (reschedule_cb) ? newSVsv (reschedule_cb) : 0;
        ev_periodic_set (w, at, interval, w->fh ? e_periodic_cb : 0);
        RETVAL = e_bless ((ev_watcher *)w, stash_periodic);
        if (!ix) START (periodic, w);
}
#line 4074 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_signal); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_signal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "loop, signal, cb");
    {
	ev_signal *	RETVAL;
	struct ev_loop *	loop;
	SV *	signal = ST(1);
	SV *	cb = ST(2);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1368 "EV.xs"
{
  	Signal signum = s_signum (signal);
        CHECK_SIG (signal, signum);

        RETVAL = e_new (sizeof (ev_signal), cb, ST (0));
        ev_signal_set (RETVAL, signum);
        if (!ix) START_SIGNAL (RETVAL);
}
#line 4112 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_signal);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_idle); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_idle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "loop, cb");
    {
	ev_idle *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1383 "EV.xs"
        RETVAL = e_new (sizeof (ev_idle), cb, ST (0));
        ev_idle_set (RETVAL);
        if (!ix) START (idle, RETVAL);
#line 4146 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_idle);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_prepare); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_prepare)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "loop, cb");
    {
	ev_prepare *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1393 "EV.xs"
        RETVAL = e_new (sizeof (ev_prepare), cb, ST (0));
        ev_prepare_set (RETVAL);
        if (!ix) START (prepare, RETVAL);
#line 4180 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_prepare);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_check); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_check)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "loop, cb");
    {
	ev_check *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1403 "EV.xs"
        RETVAL = e_new (sizeof (ev_check), cb, ST (0));
        ev_check_set (RETVAL);
        if (!ix) START (check, RETVAL);
#line 4214 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_check);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_fork); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_fork)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "loop, cb");
    {
	ev_fork *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1413 "EV.xs"
        RETVAL = e_new (sizeof (ev_fork), cb, ST (0));
        ev_fork_set (RETVAL);
        if (!ix) START (fork, RETVAL);
#line 4248 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_fork);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_child); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_child)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "loop, pid, trace, cb");
    {
	ev_child *	RETVAL;
	struct ev_loop *	loop;
	int	pid = (int)SvIV(ST(1));
	int	trace = (int)SvIV(ST(2));
	SV *	cb = ST(3);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1423 "EV.xs"
        RETVAL = e_new (sizeof (ev_child), cb, ST (0));
        ev_child_set (RETVAL, pid, trace);
        if (!ix) START (child, RETVAL);
#line 4284 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_child);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_stat); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_stat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "loop, path, interval, cb");
    {
	ev_stat *	RETVAL;
	struct ev_loop *	loop;
	SV *	path = ST(1);
	NV	interval = (NV)SvNV(ST(2));
	SV *	cb = ST(3);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1433 "EV.xs"
        RETVAL = e_new (sizeof (ev_stat), cb, ST (0));
        RETVAL->fh = newSVsv (path);
        ev_stat_set (RETVAL, SvPVbyte_nolen (RETVAL->fh), interval);
        if (!ix) START (stat, RETVAL);
#line 4321 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_stat);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_embed); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_embed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "loop, other, cb= 0");
    {
	ev_embed *	RETVAL;
	struct ev_loop *	loop;
	struct ev_loop *	other;
	SV *	cb;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	if (!(SvROK (ST(1)) && SvOBJECT (SvRV (ST(1)))
              && (SvSTASH (SvRV (ST(1))) == stash_loop || sv_derived_from (ST(1), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	other = (struct ev_loop *)SvIVX (SvRV (ST(1)));

	if (items < 3)
	    cb = 0;
	else {
	    cb = ST(2);
	}
#line 1444 "EV.xs"
{
        if (!(ev_backend (other) & ev_embeddable_backends ()))
          croak ("passed loop is not embeddable via EV::embed,");

        RETVAL = e_new (sizeof (ev_embed), cb, ST (0));
        RETVAL->fh = newSVsv (ST (1));
        ev_embed_set (RETVAL, other);
        if (!ix) START (embed, RETVAL);
}
#line 4373 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_embed);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_async); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_async)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "loop, cb");
    {
	ev_async *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1460 "EV.xs"
        RETVAL = e_new (sizeof (ev_async), cb, ST (0));
        ev_async_set (RETVAL);
        if (!ix) START (async, RETVAL);
#line 4407 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_async);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_once); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_once)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "loop, fh, events, timeout, cb");
    {
	struct ev_loop *	loop;
	SV *	fh = ST(1);
	int	events = (int)SvIV(ST(2));
	SV *	timeout = ST(3);
	SV *	cb = ST(4);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1468 "EV.xs"
        ev_once (
           loop,
           s_fileno (fh, events & EV_WRITE), events,
           SvOK (timeout) ? SvNV (timeout) : -1.,
           e_once_cb,
           newSVsv (cb)
        );
#line 4446 "EV.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_EV); /* prototype to pass -Wmissing-prototypes */
XS(boot_EV)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    const char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXSproto("EV::default_loop", XS_EV_default_loop, file, ";$");
        newXSproto("EV::default_destroy", XS_EV_default_destroy, file, "");
        newXSproto("EV::supported_backends", XS_EV_supported_backends, file, "");
        newXSproto("EV::recommended_backends", XS_EV_recommended_backends, file, "");
        newXSproto("EV::embeddable_backends", XS_EV_embeddable_backends, file, "");
        newXSproto("EV::sleep", XS_EV_sleep, file, "$");
        newXSproto("EV::time", XS_EV_time, file, "");
        newXSproto("EV::now", XS_EV_now, file, "");
        newXSproto("EV::now_update", XS_EV_now_update, file, "");
        newXSproto("EV::suspend", XS_EV_suspend, file, "");
        newXSproto("EV::resume", XS_EV_resume, file, "");
        newXSproto("EV::backend", XS_EV_backend, file, "");
        newXSproto("EV::loop_verify", XS_EV_loop_verify, file, "");
        newXSproto("EV::loop_count", XS_EV_loop_count, file, "");
        newXSproto("EV::loop_depth", XS_EV_loop_depth, file, "");
        newXSproto("EV::set_io_collect_interval", XS_EV_set_io_collect_interval, file, "$");
        newXSproto("EV::set_timeout_collect_interval", XS_EV_set_timeout_collect_interval, file, "$");
        newXSproto("EV::loop", XS_EV_loop, file, ";$");
        newXSproto("EV::unloop", XS_EV_unloop, file, ";$");
        newXSproto("EV::feed_fd_event", XS_EV_feed_fd_event, file, "$;$");
        newXSproto("EV::feed_signal_event", XS_EV_feed_signal_event, file, "$");
        newXSproto("EV::pending_count", XS_EV_pending_count, file, "");
        newXSproto("EV::invoke_pending", XS_EV_invoke_pending, file, "");
        cv = newXS("EV::io", XS_EV_io, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::io_ns", XS_EV_io, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::_ae_io", XS_EV_io, file);
        XSANY.any_i32 = 2 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::timer_ns", XS_EV_timer, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::timer", XS_EV_timer, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::periodic_ns", XS_EV_periodic, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$$$$") ;
        cv = newXS("EV::periodic", XS_EV_periodic, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$$$$") ;
        cv = newXS("EV::signal_ns", XS_EV_signal, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$$") ;
        cv = newXS("EV::signal", XS_EV_signal, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$$") ;
        cv = newXS("EV::idle_ns", XS_EV_idle, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::idle", XS_EV_idle, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::prepare", XS_EV_prepare, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::prepare_ns", XS_EV_prepare, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::check", XS_EV_check, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::check_ns", XS_EV_check, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::fork", XS_EV_fork, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::fork_ns", XS_EV_fork, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::child_ns", XS_EV_child, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::child", XS_EV_child, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::stat_ns", XS_EV_stat, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::stat", XS_EV_stat, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::embed", XS_EV_embed, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("EV::embed_ns", XS_EV_embed, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("EV::async", XS_EV_async, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::async_ns", XS_EV_async, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$") ;
        newXSproto("EV::once", XS_EV_once, file, "$$$$");
        newXS("EV::Watcher::is_active", XS_EV__Watcher_is_active, file);
        newXS("EV::Watcher::is_pending", XS_EV__Watcher_is_pending, file);
        newXS("EV::Watcher::invoke", XS_EV__Watcher_invoke, file);
        newXS("EV::Watcher::clear_pending", XS_EV__Watcher_clear_pending, file);
        newXS("EV::Watcher::feed_event", XS_EV__Watcher_feed_event, file);
        newXS("EV::Watcher::keepalive", XS_EV__Watcher_keepalive, file);
        newXS("EV::Watcher::cb", XS_EV__Watcher_cb, file);
        newXS("EV::Watcher::data", XS_EV__Watcher_data, file);
        newXS("EV::Watcher::loop", XS_EV__Watcher_loop, file);
        newXS("EV::Watcher::priority", XS_EV__Watcher_priority, file);
        newXS("EV::IO::start", XS_EV__IO_start, file);
        newXS("EV::IO::stop", XS_EV__IO_stop, file);
        newXS("EV::IO::DESTROY", XS_EV__IO_DESTROY, file);
        newXS("EV::IO::set", XS_EV__IO_set, file);
        newXS("EV::IO::fh", XS_EV__IO_fh, file);
        newXS("EV::IO::events", XS_EV__IO_events, file);
        newXS("EV::Signal::start", XS_EV__Signal_start, file);
        newXS("EV::Signal::stop", XS_EV__Signal_stop, file);
        newXS("EV::Signal::DESTROY", XS_EV__Signal_DESTROY, file);
        newXS("EV::Signal::set", XS_EV__Signal_set, file);
        newXS("EV::Signal::signal", XS_EV__Signal_signal, file);
        newXS("EV::Timer::start", XS_EV__Timer_start, file);
        newXS("EV::Timer::stop", XS_EV__Timer_stop, file);
        newXS("EV::Timer::again", XS_EV__Timer_again, file);
        newXS("EV::Timer::remaining", XS_EV__Timer_remaining, file);
        newXS("EV::Timer::DESTROY", XS_EV__Timer_DESTROY, file);
        newXS("EV::Timer::set", XS_EV__Timer_set, file);
        newXS("EV::Periodic::start", XS_EV__Periodic_start, file);
        newXS("EV::Periodic::stop", XS_EV__Periodic_stop, file);
        newXS("EV::Periodic::again", XS_EV__Periodic_again, file);
        newXS("EV::Periodic::DESTROY", XS_EV__Periodic_DESTROY, file);
        newXS("EV::Periodic::set", XS_EV__Periodic_set, file);
        newXS("EV::Periodic::at", XS_EV__Periodic_at, file);
        newXS("EV::Idle::start", XS_EV__Idle_start, file);
        newXS("EV::Idle::stop", XS_EV__Idle_stop, file);
        newXS("EV::Idle::DESTROY", XS_EV__Idle_DESTROY, file);
        newXS("EV::Prepare::start", XS_EV__Prepare_start, file);
        newXS("EV::Prepare::stop", XS_EV__Prepare_stop, file);
        newXS("EV::Prepare::DESTROY", XS_EV__Prepare_DESTROY, file);
        newXS("EV::Check::start", XS_EV__Check_start, file);
        newXS("EV::Check::stop", XS_EV__Check_stop, file);
        newXS("EV::Check::DESTROY", XS_EV__Check_DESTROY, file);
        newXS("EV::Fork::start", XS_EV__Fork_start, file);
        newXS("EV::Fork::stop", XS_EV__Fork_stop, file);
        newXS("EV::Fork::DESTROY", XS_EV__Fork_DESTROY, file);
        newXS("EV::Child::start", XS_EV__Child_start, file);
        newXS("EV::Child::stop", XS_EV__Child_stop, file);
        newXS("EV::Child::DESTROY", XS_EV__Child_DESTROY, file);
        newXS("EV::Child::set", XS_EV__Child_set, file);
        cv = newXS("EV::Child::pid", XS_EV__Child_pid, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Child::rstatus", XS_EV__Child_pid, file);
        XSANY.any_i32 = 2 ;
        cv = newXS("EV::Child::rpid", XS_EV__Child_pid, file);
        XSANY.any_i32 = 1 ;
        newXS("EV::Stat::start", XS_EV__Stat_start, file);
        newXS("EV::Stat::stop", XS_EV__Stat_stop, file);
        newXS("EV::Stat::DESTROY", XS_EV__Stat_DESTROY, file);
        newXS("EV::Stat::set", XS_EV__Stat_set, file);
        newXS("EV::Stat::path", XS_EV__Stat_path, file);
        newXS("EV::Stat::interval", XS_EV__Stat_interval, file);
        cv = newXS("EV::Stat::prev", XS_EV__Stat_prev, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Stat::stat", XS_EV__Stat_prev, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Stat::attr", XS_EV__Stat_prev, file);
        XSANY.any_i32 = 2 ;
        newXS("EV::Embed::start", XS_EV__Embed_start, file);
        newXS("EV::Embed::stop", XS_EV__Embed_stop, file);
        newXS("EV::Embed::DESTROY", XS_EV__Embed_DESTROY, file);
        newXS("EV::Embed::set", XS_EV__Embed_set, file);
        newXS("EV::Embed::other", XS_EV__Embed_other, file);
        newXS("EV::Embed::sweep", XS_EV__Embed_sweep, file);
        newXS("EV::Async::start", XS_EV__Async_start, file);
        newXS("EV::Async::stop", XS_EV__Async_stop, file);
        newXS("EV::Async::DESTROY", XS_EV__Async_DESTROY, file);
        newXS("EV::Async::send", XS_EV__Async_send, file);
        newXS("EV::Async::async_pending", XS_EV__Async_async_pending, file);
        newXS("EV::Loop::new", XS_EV__Loop_new, file);
        newXS("EV::Loop::DESTROY", XS_EV__Loop_DESTROY, file);
        newXS("EV::Loop::loop_fork", XS_EV__Loop_loop_fork, file);
        newXS("EV::Loop::loop_verify", XS_EV__Loop_loop_verify, file);
        newXS("EV::Loop::now", XS_EV__Loop_now, file);
        newXS("EV::Loop::now_update", XS_EV__Loop_now_update, file);
        newXS("EV::Loop::suspend", XS_EV__Loop_suspend, file);
        newXS("EV::Loop::resume", XS_EV__Loop_resume, file);
        newXS("EV::Loop::set_io_collect_interval", XS_EV__Loop_set_io_collect_interval, file);
        newXS("EV::Loop::set_timeout_collect_interval", XS_EV__Loop_set_timeout_collect_interval, file);
        newXS("EV::Loop::backend", XS_EV__Loop_backend, file);
        newXS("EV::Loop::loop_count", XS_EV__Loop_loop_count, file);
        newXS("EV::Loop::loop_depth", XS_EV__Loop_loop_depth, file);
        newXS("EV::Loop::loop", XS_EV__Loop_loop, file);
        newXS("EV::Loop::unloop", XS_EV__Loop_unloop, file);
        newXS("EV::Loop::feed_fd_event", XS_EV__Loop_feed_fd_event, file);
        newXS("EV::Loop::pending_count", XS_EV__Loop_pending_count, file);
        newXS("EV::Loop::invoke_pending", XS_EV__Loop_invoke_pending, file);
#if XSubPPtmpAAAA
        newXS("EV::Loop::feed_signal_event", XS_EV__Loop_feed_signal_event, file);
#endif
        cv = newXS("EV::Loop::io_ns", XS_EV__Loop_io, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::io", XS_EV__Loop_io, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::timer", XS_EV__Loop_timer, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::timer_ns", XS_EV__Loop_timer, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::periodic", XS_EV__Loop_periodic, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::periodic_ns", XS_EV__Loop_periodic, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::signal_ns", XS_EV__Loop_signal, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::signal", XS_EV__Loop_signal, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::idle", XS_EV__Loop_idle, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::idle_ns", XS_EV__Loop_idle, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::prepare", XS_EV__Loop_prepare, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::prepare_ns", XS_EV__Loop_prepare, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::check", XS_EV__Loop_check, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::check_ns", XS_EV__Loop_check, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::fork", XS_EV__Loop_fork, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::fork_ns", XS_EV__Loop_fork, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::child_ns", XS_EV__Loop_child, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::child", XS_EV__Loop_child, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::stat", XS_EV__Loop_stat, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::stat_ns", XS_EV__Loop_stat, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::embed", XS_EV__Loop_embed, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::embed_ns", XS_EV__Loop_embed, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::async", XS_EV__Loop_async, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::async_ns", XS_EV__Loop_async, file);
        XSANY.any_i32 = 1 ;
        newXS("EV::Loop::once", XS_EV__Loop_once, file);
    }

    /* Initialisation Section */

#line 347 "EV.xs"
{
  HV *stash = gv_stashpv ("EV", 1);

  static const struct {
    const char *name;
    IV iv;
  } *civ, const_iv[] = {
#   define const_iv(pfx, name) { # name, (IV) pfx ## name },
    const_iv (EV_, MINPRI)
    const_iv (EV_, MAXPRI)

    const_iv (EV_, UNDEF)
    const_iv (EV_, NONE)
    const_iv (EV_, READ)
    const_iv (EV_, WRITE)
    const_iv (EV_, IO)
    const_iv (EV_, TIMEOUT)
    const_iv (EV_, TIMER)
    const_iv (EV_, PERIODIC)
    const_iv (EV_, SIGNAL)
    const_iv (EV_, CHILD)
    const_iv (EV_, STAT)
    const_iv (EV_, IDLE)
    const_iv (EV_, PREPARE)
    const_iv (EV_, CHECK)
    const_iv (EV_, EMBED)
    const_iv (EV_, FORK)
    const_iv (EV_, ASYNC)
    const_iv (EV_, CUSTOM)
    const_iv (EV_, ERROR)

    const_iv (EV, LOOP_NONBLOCK)
    const_iv (EV, LOOP_ONESHOT)

    const_iv (EV, UNLOOP_CANCEL)
    const_iv (EV, UNLOOP_ONE)
    const_iv (EV, UNLOOP_ALL)

    const_iv (EV, BACKEND_SELECT)
    const_iv (EV, BACKEND_POLL)
    const_iv (EV, BACKEND_EPOLL)
    const_iv (EV, BACKEND_KQUEUE)
    const_iv (EV, BACKEND_DEVPOLL)
    const_iv (EV, BACKEND_PORT)
    const_iv (EV, BACKEND_ALL)
    const_iv (EV, FLAG_AUTO)
    const_iv (EV, FLAG_FORKCHECK)
    const_iv (EV, FLAG_SIGNALFD)
    const_iv (EV, FLAG_NOENV)
    const_iv (EV, FLAG_NOSIGFD) /* compatibility, always 0 */
    const_iv (EV, FLAG_NOINOTIFY)

    const_iv (EV_, VERSION_MAJOR)
    const_iv (EV_, VERSION_MINOR)
  };

  for (civ = const_iv + sizeof (const_iv) / sizeof (const_iv [0]); civ-- > const_iv; )
    newCONSTSUB (stash, (char *)civ->name, newSViv (civ->iv));

  stash_loop     = gv_stashpv ("EV::Loop"    , 1);
  stash_watcher  = gv_stashpv ("EV::Watcher" , 1);
  stash_io       = gv_stashpv ("EV::IO"      , 1);
  stash_timer    = gv_stashpv ("EV::Timer"   , 1);
  stash_periodic = gv_stashpv ("EV::Periodic", 1);
  stash_signal   = gv_stashpv ("EV::Signal"  , 1);
  stash_idle     = gv_stashpv ("EV::Idle"    , 1);
  stash_prepare  = gv_stashpv ("EV::Prepare" , 1);
  stash_check    = gv_stashpv ("EV::Check"   , 1);
  stash_child    = gv_stashpv ("EV::Child"   , 1);
  stash_embed    = gv_stashpv ("EV::Embed"   , 1);
  stash_stat     = gv_stashpv ("EV::Stat"    , 1);
  stash_fork     = gv_stashpv ("EV::Fork"    , 1);
  stash_async    = gv_stashpv ("EV::Async"   , 1);

  {
    SV *sv = perl_get_sv ("EV::API", TRUE);
             perl_get_sv ("EV::API", TRUE); /* silence 5.10 warning */

    /* the poor man's shared library emulator */
    evapi.ver                  = EV_API_VERSION;
    evapi.rev                  = EV_API_REVISION;
    evapi.sv_fileno            = sv_fileno;
    evapi.sv_signum            = s_signum;
    evapi.supported_backends   = ev_supported_backends ();
    evapi.recommended_backends = ev_recommended_backends ();
    evapi.embeddable_backends  = ev_embeddable_backends ();
    evapi.time_                = ev_time;
    evapi.sleep_               = ev_sleep;
    evapi.loop_new             = ev_loop_new;
    evapi.loop_destroy         = ev_loop_destroy;
    evapi.loop_fork            = ev_loop_fork;
    evapi.loop_count           = ev_loop_count;
    evapi.loop_depth           = ev_loop_depth;
    evapi.set_userdata         = ev_set_userdata;
    evapi.userdata             = ev_userdata;
    evapi.now                  = ev_now;
    evapi.now_update           = ev_now_update;
    evapi.suspend              = ev_suspend;
    evapi.resume               = ev_resume;
    evapi.backend              = ev_backend;
    evapi.unloop               = ev_unloop;
    evapi.invoke_pending       = ev_invoke_pending;
    evapi.pending_count        = ev_pending_count;
    evapi.set_loop_release_cb  = ev_set_loop_release_cb;
    evapi.set_invoke_pending_cb= ev_set_invoke_pending_cb;
    evapi.ref                  = ev_ref;
    evapi.unref                = ev_unref;
    evapi.loop                 = ev_loop;
    evapi.once                 = ev_once;
    evapi.io_start             = ev_io_start;
    evapi.io_stop              = ev_io_stop;
    evapi.timer_start          = ev_timer_start;
    evapi.timer_stop           = ev_timer_stop;
    evapi.timer_again          = ev_timer_again;
    evapi.timer_remaining      = ev_timer_remaining;
    evapi.periodic_start       = ev_periodic_start;
    evapi.periodic_stop        = ev_periodic_stop;
    evapi.signal_start         = ev_signal_start;
    evapi.signal_stop          = ev_signal_stop;
    evapi.idle_start           = ev_idle_start;
    evapi.idle_stop            = ev_idle_stop;
    evapi.prepare_start        = ev_prepare_start;
    evapi.prepare_stop         = ev_prepare_stop;
    evapi.check_start          = ev_check_start;
    evapi.check_stop           = ev_check_stop;
    evapi.child_start          = ev_child_start;
    evapi.child_stop           = ev_child_stop;
    evapi.stat_start           = ev_stat_start;
    evapi.stat_stop            = ev_stat_stop;
    evapi.stat_stat            = ev_stat_stat;
    evapi.embed_start          = ev_embed_start;
    evapi.embed_stop           = ev_embed_stop;
    evapi.embed_sweep          = ev_embed_sweep;
    evapi.fork_start           = ev_fork_start;
    evapi.fork_stop            = ev_fork_stop;
    evapi.async_start          = ev_async_start;
    evapi.async_stop           = ev_async_stop;
    evapi.async_send           = ev_async_send;
    evapi.clear_pending        = ev_clear_pending;
    evapi.invoke               = ev_invoke;

    sv_setiv (sv, (IV)&evapi);
    SvREADONLY_on (sv);
  }
#ifndef _WIN32
  pthread_atfork (0, 0, ev_default_fork);
#endif
}

#if XSubPPtmpAAAA
#endif
#line 4874 "EV.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

